/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.person.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.person.entity.Kreditinstitut;
import de.ivu.elect.business.person.entity.KreditinstitutUK;

public abstract class AbstractKreditinstitutDAO extends de.ivu.elect.jee.entity.AbstractDAO<Kreditinstitut,
        de.ivu.elect.business.person.entity.KreditinstitutPK
    , KreditinstitutUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractKreditinstitutDAO.class);

  public AbstractKreditinstitutDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.person.entity.KreditinstitutPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Kreditinstitut findByPrimaryKey(
        de.ivu.elect.business.person.entity.KreditinstitutPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Kreditinstitut findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Kreditinstitut.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: AllNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Kreditinstitut o<br>
      * SQL: <br>
      */
     public java.util.List<Kreditinstitut> findByAll() {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  
                              return
                              getEntityManager().
                                createNamedQuery("KREDITINSTITUT.All")
                                                            .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByAll - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Kreditinstitut, findByAll - NonUniqueResultException, Parameter: "
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByAll(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.person.entity.KreditinstitutUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.person.entity.KreditinstitutUK uk,
        de.ivu.elect.business.person.entity.KreditinstitutPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.person.entity.Kreditinstitut findByUK(de.ivu.elect.business.person.entity.KreditinstitutUK uk){

    try {
     return (de.ivu.elect.business.person.entity.Kreditinstitut) getEntityManager().createNamedQuery("KREDITINSTITUT.UK")
                  .setParameter(1, uk
                .getBankleitzahl ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Kreditinstitut, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}